HDU 1010(剪枝+深搜)

来源:互联网 发布:你知我所想我知你所要 编辑:程序博客网 时间:2024/06/06 10:29

Tempter of the Bone

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 62107    Accepted Submission(s): 16992


Problem Description
The doggie found a bone in an ancient maze, which fascinated him a lot. However, when he picked it up, the maze began to shake, and the doggie could feel the ground sinking. He realized that the bone was a trap, and he tried desperately to get out of this maze.

The maze was a rectangle with sizes N by M. There was a door in the maze. At the beginning, the door was closed and it would open at the T-th second for a short period of time (less than 1 second). Therefore the doggie had to arrive at the door on exactly the T-th second. In every second, he could move one block to one of the upper, lower, left and right neighboring blocks. Once he entered a block, the ground of this block would start to sink and disappear in the next second. He could not stay at one block for more than one second, nor could he move into a visited block. Can the poor doggie survive? Please help him.
 

Input
The input consists of multiple test cases. The first line of each test case contains three integers N, M, and T (1 < N, M < 7; 0 < T < 50), which denote the sizes of the maze and the time at which the door will open, respectively. The next N lines give the maze layout, with each line containing M characters. A character is one of the following:

'X': a block of wall, which the doggie cannot enter; 
'S': the start point of the doggie; 
'D': the Door; or
'.': an empty block.

The input is terminated with three 0's. This test case is not to be processed.
 

Output
For each test case, print in one line "YES" if the doggie can survive, or "NO" otherwise.
 

Sample Input
4 4 5S.X...X...XD....3 4 5S.X...X....D0 0 0
 

Sample Output
NOYES
 


题意:输入一个n*m的迷宫,和一个T:可以在迷宫中生存的最大时间。S为起点,D为终点。并且,每个格子只能踩一次,且只能维持一秒,然后该块地板就会塌陷。且你必须每秒走一步,且到D点时,所用时间为T。。。
倘若直接搜索,果断TLE,所以需要技巧上的剪枝:

#include<stdio.h>#include<math.h>#include<algorithm>#include<iostream>    using namespace std;    int sx,sy,ex,ey;    int n,m;   char map[10][10];  int flag;  int d[4][2]={0,1,1,0,0,-1,-1,0};  // 下、右、上、左  void dfs(int x,int y,int t)    {         if(flag==1) return ;      // 剩余时间不足以走到终点 或者 当前点与终点横纵坐标差的和 与 剩余时间之差奇偶性不同。则直接否决返回      if(t<abs(ex-x)+abs(ey-y)||(t-abs(ex-x)+abs(ey-y))%2) return ;       // 时间用完,则判断是否到终点并返回      if(t==0)       {          if(x==ex&&y==ey)  {flag=1; return ;}          else { return ;  }      }      for(int i=0;i<4;i++)                       {          int nx=x+d[i][0],ny=y+d[i][1];          // 排除:1越界,2不是'.'或不是终点          if (nx>0&&nx<=n&&ny>0&&ny<=m&&(map[nx][ny]=='.'||map[nx][ny]=='D'))          {              map[nx][ny]='X';//标记当前点走过                       dfs(nx,ny,t-1) ;             map[nx][ny]='.';//还原状态                   }        }        return ;    }    int main()    {        char str[10];          int t;        while (scanf("%d%d%d",&n,&m,&t)!=EOF)        {               if(n==0&&m==0&&t==0) return 0;            for (int i=1;i<=n;i++)            {                scanf("%s",str);                for (int j=1;j<=m;j++)                {                    map[i][j]=str[j-1];                       if(map[i][j]=='S')  sx=i,sy=j;                    else if(map[i][j]=='D') ex=i,ey=j;                }            }                     flag=0;            dfs(sx,sy,t);            if(flag==0) printf("NO\n");            else printf("YES\n");         }        return 0;    }  




0 0